# Bonfire Fingerprinting

Bonfire Fingerprinting is a Bonfire extensibility plugin that "fingerprints" respondents in order to prevent bots/attacks on surveys, the main use case is unauthenticated surveys with incentives such as prize draws where respondents are randomly selected, if a respondent can answer the survey many times they are more likely to get the prize.

> **Warning: This is by no means fool-proof, it will not be able to detect the most sophisticated bots, and it relies on the use of cookies/storage on the respondent machine so the respondent must be made aware that cookies are being used for the survey**

## How It Works

When an unauthenticated respondent takes a survey the fingerprinting plugin tries to determine if this respondent has already taken this survey, how many times, and when. By setting the parameters detailed below you will be able to detect if a particular respondent has taken the survey in a malicious or unfair manner.
Each respondent gets a unique GUID, and along with some other tracking data such as the date and the number of times they took the survey, it is stored on their machine. **The data gets updated every time the respondent takes the survey and can be entered into several hidden fields in the survey visible in reporting, you will then be able to see and filter on this data - it is up to you / the analysts to determine which respondents are to be filtered out or watched, this plugin only collects the data**. See the table below explaining all of the different fingerprinting data available for reporting.

| data | description |
| ------ | ------ |
| GUID | Unique GUID generated by the plugin for each respondent, only unique to the respondent so filtering on this will show all responses from one machine/individial |
| numberOfVisits | Number of visits / number of times the respondent took the survey |
| lastSetDate | Last time the respondent took the survey (last time the plugin set the date on the respondent machine) |
| moreThanXVisits | **Replace the X with an integer above 0**. Once the respondent has taken the survey more than this number of times this field will be set to true |
| errorLog | If the plugin is unable to run properly for any reason it will try to enter a detailed error message here, this can be useful if the respondent tries to block it from running, like disabling cookies |

## Usage

The plugin is inserted into your Bonfire survey with a few simple steps.
1. Start with the **Survey Setup** section where you will create at least one field to capture some fingerprinting data for reporting (see the How It Works section above for info on which data is available).
2. Continue to the **Client Extensibility Setup** section below to set up your required JavaScript configuration.
3. Add a little bit of JavaScript into the client extensibility to run the script, detailed in the **Installation** section.

### Survey Setup

At least one fingerprinting survey field is required in order to make this plugin useful. See the table below for all of the allowed field types for each data type.

| data | field type |
| ------ | ------ |
| GUID | must be a short or long text box, short text box is preferred since the GUID will not exceed the character limit |
| numberOfVisits | must be a short, long text box, or numeric type, numeric type is preferred since this will always be a number |
| lastSetDate | must be a short or long text box, short text box is preferred since the date string will not exceed the character limit |
| moreThanXVisits | must be a radio or dropdown field. The **first** option in the radio/dropdown must be the value for **false/no** (when the respondent has not exceeded yet X number of visits) and the **second** option must be the value for **true/yes** (when the respondent has exceeded the X number of visits). **Replace the X with an integer above 0**  |
| errorLog | must be a short or long text box, long text box is preferred since some long error messages might exceed the character limit (but is unlikely) |

**These fields must NOT be on a page that has all "always hide" questions, it must be on a page that has text or questions visible to respondents.**
**These fields' display logic must NOT be set to "always hide", set it to "always show".**

The fields do not have to be all on the same page but it there is no reason to separate them. We recommend placing them after the very first page in the survey if possible.

> Hint: The plugin will hide these fields but you wish to be extra sure they are hidden or just want peace of mind you can hide them with CSS by giving them a CSS class in the question editor, this will not affect the plugin.

### Client Extensibility Setup

You will need to configure the settings for the plugin. Below is an example configuration that you will need to modify to meet your requirements.

```Javascript
{
    fieldTags: {
        GUID: 'FP_GUID',
        numberOfVisits: 'FP_VISITS',
        lastSetDate: 'FP_LAST_ACCESSED',
        moreThan3Visits: 'FP_MORE_THAN_3_VISITS',
        errorLog: 'FP_ERROR'
    },
    cookieExpiresAfterDays: 7,
    cookieName: 'mcxSurveyFingerprint',
    hideFields: true,
    onlyOnSurveyFinish: true
}
```

**These are all the currently supported configurations. See the example above as a reference**
- **fieldTags**: must be an object containing any of the following keys, all keys are optional. All of the fields that store fingerprinting data for reporting are entered here.
    - GUID: must be a string. Optional. The tag of the field that will store the GUID value generated by the script for each respondent.
    - numberOfVisits: must be a string. Optional. The tag of the field that will store the number of times this respondent took this survey.
    - lastSetDate: must be a string. Optional. The tag of the field that will store the most recent time this respondent took this survey.
    - moreThanXVisits: must be a string. Optional. The tag of the field that will store if the respondent took the survey more than X times. **Replace the X with an integer above 0**.
    - errorLog: must be a string. Optional. The tag of the field that will store any error messages generated by the plugin.
- **cookieExpiresAfterDays**: must be an integer above 0. Optional, default is 7. The cookie in which all fingerprinting data is saved on the respondent's machine will expire/be deleted after this number of days, after it is deleted all subsequent fingerprinting data for this respondent will reset and in reporting it will appear as if they had never taken the survey before.
- **cookieName**: must be a string. Optional, default is "mcxSurveyFingerprint". The name of the cookie that is saved on the respondent machine.
- **hideFields**: must be a boolean. Optional, default is true. If true the plugin will hide all the fields entered in 'fieldTags', if false it will no nothing.
- **onlyOnSurveyFinish**: must be a boolean. Optional, default is true. If true the cookie will only be saved to the respondent's machine (or modified, if exists) when the respondent has reached the thank you page thereby only recording completes. This allows blocking of respondents who have completed the survey with survey display logic (listening to the moreThanXVisits field). If false the cookie will be set to the respondent's machine on the first page load. This option does not affect the way the fields in "fieldTags" are set.

> Hint: Renaming "cookieName" to something more inconspicuous might delay some actively malicious respondents and aid in fingerprinting validity.

### Installation

This assumes you have already prepared your required configurations in the Setup sections above.

1. In the Bonfire editor open **Options > Client Extensibility**.
2. In the **External Javascript Files** section paste **https://platform-services.custom.eu.mcx.cloud/bonfire-extensibility/fingerprinting/extensibility.js** - this is the main script, it is hosted externally.
3. In the **Include Javascript** section you must run a function called **surveyFingerprint**, it accepts one argument which is the configuration object you created earlier. See the example below. This does not need to be run after any page events like document ready, simply run it at the top-level at the beginning or end away from any existing code.

```Javascript
surveyFingerprint({
    fieldTags: {
        GUID: 'FP_GUID',
        numberOfVisits: 'FP_VISITS',
        lastSetDate: 'FP_LAST_ACCESSED',
        moreThan3Visits: 'FP_MORE_THAN_3_VISITS',
        errorLog: 'FP_ERROR'
    },
    cookieExpiresAfterDays: 7,
    cookieName: 'mcxSurveyFingerprint',
    hideFields: true
});
```

4. Try it out and enjoy your new fingerprinting functionality!

## Troubleshooting

### It doesn't work

Try going through the setup and installation procedures again, ensuring all of the points are met, be sure that display logic is set correctly!

### The numberOfVisits value does not always increase incrementally but misses values, e.g. taking the survey the first time it's 1, the second time it's 3.

This is most likely because the first page of the survey was laoded more than once or refreshed and the fingerprinting collection fields are also on the first page. There is a session ID value generated by Bonfire for unauthenticated surveys which this plugin uses to determine if it's a new session or not (if the respondent just clicked the back or next buttons) but since it's unauthenticated there is no way for Bonfire or the plugin to know which session this survey is in on the first page, this can cause the numberOfVisits to skip a value. To fix this try moving the fields away from the first page.
